'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var lr = require('@lezer/lr');
var language = require('@codemirror/language');
var highlight = require('@lezer/highlight');
var view = require('@codemirror/view');
var lint = require('@codemirror/lint');
var autocomplete = require('@codemirror/autocomplete');

// This file was generated by lezer-generator. You probably shouldn't edit it.
const parser = lr.LRParser.deserialize({
  version: 14,
  states: "#`OVQPOOOVQPO'#ClQhQPOOOOQO'#Ck'#CkOmQPO'#CkOrQPO,59WOVQPO,59XOzQPO'#CeOOQO,59V,59VOOQO1G.r1G.rOOQO1G.s1G.sO!RQPO'#CnO!^QPO,59POVQPO'#CgO!cQPO,59YOOQO1G.k1G.kO!kQPO,59ROOQO-E6e-E6e",
  stateData: "!y~O^OS~OQRORROSROTPOWSO~OVUO~OTVO~OUXOVUO~OUbP~PVOVUOY]OUbX~OU_O~OY]OUba~OVUOUZaYZa~OVR~",
  goto: "!WcPPPPPPPPPdPgPPPm||!TRWSQ^ZRa^QQOQTPQYUQZVR`]ZROPUV]R[V",
  nodeNames: "⚠ NuFormula String Number Item ( ) Operator Keyword ArgList Comma",
  maxTerm: 18,
  nodeProps: [
    ["closedBy", 5,")"],
    ["openedBy", 6,"("]
  ],
  skippedNodes: [0],
  repeatNodeCount: 1,
  tokenData: ")t~RcXY!^YZ!^]^!^pq!^rs!cxy${yz%Qz{%V{|%[|}&Q}!O%[!O!P%g!P!Q%V!Q![%u!^!_&V!_!`%V!`!a&b!c!}&j#o#p&r~!cO^~~!fWpq!cqr!crs#Os#O!c#O#P#T#P;'S!c;'S;=`$u<%lO!c~#TOQ~~#WXrs!c!P!Q!c#O#P!c#U#V!c#Y#Z!c#b#c!c#f#g!c#h#i!c#i#j#s~#vR!Q![$P!c!i$P#T#Z$P~$SR!Q![$]!c!i$]#T#Z$]~$`R!Q![$i!c!i$i#T#Z$i~$lR!Q![!c!c!i!c#T#Z!c~$xP;=`<%l!c~%QOT~~%VOU~~%[OV~~%aQV~!O!P%g!Q![%u~%jP!Q![%m~%rPR~!Q![%m~%zQR~!O!P%m!Q![%u~&VOY~~&[QV~!_!`%V!`!a%V~&gPV~!_!`%V~&oPW~!c!}&j~&uR!Q!['O!c!i'O#T#Z'O~'RS}!O'_!Q!['O!c!i'O#T#Z'O~'bR!Q!['k!c!i'k#T#Z'k~'nS}!O'z!Q!['k!c!i'k#T#Z'k~'}R!Q![(W!c!i(W#T#Z(W~(ZS}!O(g!Q![(W!c!i(W#T#Z(W~(jR!Q![(s!c!i(s#T#Z(s~(vS}!O)S!Q![(s!c!i(s#T#Z(s~)VR!Q![)`!c!i)`#T#Z)`~)cS!Q![)`!c!i)`#T#Z)`#q#r)o~)tOS~",
  tokenizers: [0],
  topRules: {"NuFormula":[0,1]},
  tokenPrec: 84
});

/**
 * 輸出 表單元件 decoration 插件
 *
 * @param {object} formItems - 所有表單元件
 * @returns {ViewPlugin}
 */
function nuformulaItemWidget(formItems) {
    // 表單項目單元
    class ItemWidget extends view.WidgetType {
        constructor(item, isError) {
            var _a;
            super();
            this.text = (_a = item.options) === null || _a === void 0 ? void 0 : _a.label;
            this.isError = isError;
        }
        toDOM() {
            let wrap = document.createElement("span");
            wrap.style.cssText = `
          border-radius: 4px;
          color: #6e7796;
          padding: 2px 4px;
          background-color: ${this.isError ? "#f00" : "#e9ebf2"};
        `;
            wrap.innerText = this.text;
            return wrap;
        }
        ignoreEvent() {
            return false;
        }
    }
    /**
     * 建立元件標籤
     *
     * @param { EditorView } view - EditorView
     * @returns { DecorationSet }
     */
    function itemTag(view$1) {
        let widgets = [];
        for (let { from, to } of view$1.visibleRanges) {
            language.syntaxTree(view$1.state).iterate({
                from,
                to,
                enter: (node) => {
                    var _a;
                    if (node.name == "Item") {
                        const itemSn = view$1.state.doc.sliceString(node.from + 1, node.to - 1);
                        const item = (_a = formItems[itemSn]) !== null && _a !== void 0 ? _a : {};
                        let deco = view.Decoration.replace({
                            widget: new ItemWidget(item, node.type.isError),
                            side: 1,
                        });
                        widgets.push(deco.range(node.from, node.to));
                    }
                },
            });
        }
        return view.Decoration.set(widgets);
    }
    return view.ViewPlugin.fromClass(class {
        constructor(view) {
            this.decorations = itemTag(view);
        }
        update(update) {
            if (update.docChanged || update.viewportChanged)
                this.decorations = itemTag(update.view);
        }
    }, {
        decorations: (instance) => instance.decorations,
        provide: (plugin) => view.EditorView.atomicRanges.of((view$1) => {
            var _a;
            return ((_a = view$1.plugin(plugin)) === null || _a === void 0 ? void 0 : _a.decorations) || view.Decoration.none;
        }),
    });
}

/******************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

function __rest(s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
}

typeof SuppressedError === "function" ? SuppressedError : function (error, suppressed, message) {
    var e = new Error(message);
    return e.name = "SuppressedError", e.error = error, e.suppressed = suppressed, e;
};

exports.funcName = void 0;
(function (funcName) {
    funcName["SUM"] = "SUM";
    funcName["AVERAGE"] = "AVERAGE";
    funcName["IF"] = "IF";
    funcName["CONCAT"] = "CONCAT";
})(exports.funcName || (exports.funcName = {}));
const MAX_INTEGER = "99999999999";
/**
 * 對象是否為數字
 *
 * @param {any} value - 對象
 * @returns  {boolean}
 */
function isNumber(value) {
    return typeof value === "number" && !Number.isNaN(value);
}
/**
 * 對象是否為空
 * @param {any} value - 對象
 * @returns {boolean}
 */
function isEmptyValue(value) {
    if (isNumber(value))
        return false;
    return value === undefined || !value.length;
}
/**
 * 判斷是否超過輸入限制 (整數 11 位數、小數點4位)
 *
 * @param {string} string - 數字字串
 * @returns {boolean}
 */
function isMaximumNumber(string) {
    return /^9{11}(\.9{1,4})?$/.test(string);
}
/**
 * 取得相對應小數點的數入最大值
 *
 * @param {number} fractionLength - 小數點位數
 * @returns {string}
 */
function getMaximumNumber(fractionLength = 0) {
    return [MAX_INTEGER, MAX_INTEGER.slice(0, fractionLength)].join(".");
}
/**
 * 擷取可接受的最大值
 *
 * @param {number | string} number - 當前數字
 * @param {number} precision - 小數點精確位數
 * @returns {number}
 */
function truncateMaxNumber(number, precision = 4) {
    var _a, _b, _c, _d;
    let formatValue = String(number);
    // 分離數字的正負號
    let sign = /^\-\d+/.test(formatValue) ? -1 : 1;
    if (sign < 0)
        formatValue = formatValue.replace(/^\-/, "");
    // 若數字元件進入科學記號，強制更新為最大值
    if (/^\d(\.\d+)?\e\+\d+$/.test(formatValue)) {
        formatValue = getMaximumNumber(precision);
    }
    let parts = formatValue.toString().split(".");
    // 若小數部分超過 4 位，並且尚未超過數入限制，強制四捨五入至小數點第四位
    let fractionLength = (_b = (_a = parts[1]) === null || _a === void 0 ? void 0 : _a.length) !== null && _b !== void 0 ? _b : 0;
    if (fractionLength > 4 && !isMaximumNumber(formatValue)) {
        formatValue = String(Math.round(Math.round(Number(formatValue) * Math.pow(10, 4 + 1)) / 10) /
            Math.pow(10, 4));
    }
    // 若小數部分超過 4 位，但是已經超過數入限制，強制更新為最大值
    if (fractionLength > 4 && isMaximumNumber(formatValue)) {
        formatValue = getMaximumNumber(precision);
    }
    // 若整數部分超過 11 位，強制更新為最大值
    let integerLength = (_d = (_c = parts[0]) === null || _c === void 0 ? void 0 : _c.length) !== null && _d !== void 0 ? _d : 0;
    if (integerLength > 11) {
        formatValue = getMaximumNumber(precision);
    }
    return Number(formatValue) * sign;
}

const ERROR = {
    unmatchedParen: "unmatchedParen",
    unmatchedQuote: "unmatchedQuote",
    invalidItem: "invalidItem",
    invalidOperator: "invalidOperator",
    missingOperator: "missingOperator",
    invalidFuncName: "invalidFuncName",
    invalidArgCount: "invalidArgCount",
    syntaxError: "syntaxError", // -------------- 語法錯誤
};
const SYNTAX_empty = `^$`; // ----------------- 空字串
const SYNTAX_comma = `(,)`; // ---------------- 逗號 ,
const SYNTAX_slash = `(\\\\)`; // ------------- 反斜線 \
const SYNTAX_upper_case = `([A-Z])`; // ------- 大寫字母 A-Z
const SYNTAX_digit = `(\\d)`; // -------------- 數字 0-9
const SYNTAX_dot = `(\\.)`; // ---------------- 小數點 .
const SYNTAX_equal = `(\\=)`; // -------------- 等號 =
const SYNTAX_gt = `(\\>)`; // ----------------- 大於 >
const SYNTAX_lt = `(\\<)`; // ----------------- 小於 <
const SYNTAX_plus = `(\\+)`; // --------------- 加號 +
const SYNTAX_minus = `(\\-)`; // -------------- 減號 -
const SYNTAX_time = `(\\*)`; // --------------- 乘號 *
const SYNTAX_divide = `(\\/)`; // ------------- 除號 /
const SYNTAX_quote = `(")`; // ---------------- 引號 "
const SYNTAX_paren_l = `(\\()`; // ------------ 左括號 (
const SYNTAX_paren_r = `(\\))`; // ------------ 右括號 )
const SYNTAX_bracket_l = `(\\{)`; // ---------- 左大括號 {
const SYNTAX_bracket_r = `(\\})`; // ---------- 右大括號 }
const SYNTAX_hex = `[0-9a-fA-F]`; // ---------- 十六進位字符
// 表單項目序號
const SYNTAX_item = `^${SYNTAX_hex}{8}\\-${SYNTAX_hex}{4}\\-${SYNTAX_hex}{4}\\-${SYNTAX_hex}{4}\\-${SYNTAX_hex}{12}$`;
// 正負符號
const SYNTAX_sign = `(${SYNTAX_plus}|${SYNTAX_minus})`;
// 數學運算符號
const SYNTAX_arith = `(${SYNTAX_time}|${SYNTAX_divide})`;
// 布林比較符號
const SYNTAX_bool = `(${SYNTAX_equal}|${SYNTAX_gt}|${SYNTAX_lt})`;
// 願算子符號
const SYNTAX_operator = `(${SYNTAX_sign}|${SYNTAX_arith}|${SYNTAX_bool})`;
// 是否為一個參數的合法開頭
const SYNTAX_start_of_arg = `(${SYNTAX_quote}|${SYNTAX_paren_l}|${SYNTAX_bracket_l}|${SYNTAX_digit}|${SYNTAX_upper_case}|${SYNTAX_sign})`;
// 是否為一個參數的合法結尾
const SYNTAX_end_of_arg = `(${SYNTAX_quote}|${SYNTAX_paren_r}|${SYNTAX_bracket_r}|${SYNTAX_digit})`;
// 是否為一個參數的合法前綴
const SYNTAX_lead_to_arg = `(${SYNTAX_empty}|${SYNTAX_comma}|${SYNTAX_paren_l}|${SYNTAX_operator})`;
// 是否為一個參數的合法後綴
const SYNTAX_trail_to_arg = `(${SYNTAX_empty}|${SYNTAX_comma}|${SYNTAX_paren_r}|${SYNTAX_operator})`;
// 是否為一個函式的合法結尾
const SYNTAX_end_of_func = `(${SYNTAX_upper_case}|${SYNTAX_paren_l})`;
// 是否為註冊的函式
const SYNTAX_valid_func = `(${Object.values(exports.funcName).join("|")})`;
/**
 * 判斷字符類型
 *
 * @param {string} syntax - 字符規則
 * @param {string} char - 比對字符
 * @returns {boolean}
 */
const isSyntax = (syntax, char) => {
    if (isEmptyValue(syntax))
        return false;
    const regex = new RegExp(syntax);
    return regex.test(char);
};
/**
 * 檢查是否前後為合法的參數
 *
 * @param {string} prevChar - 前一字符
 * @param {string} nextChar - 後一字符
 * @returns {boolean}
 */
const isValidOperator = (prevChar, nextChar) => {
    return (isSyntax(SYNTAX_end_of_arg, prevChar) &&
        isSyntax(SYNTAX_start_of_arg, nextChar));
};
/**
 * 判斷函式參數數量是否合法
 *
 * @param {FuncArg} - 函式佇列
 * @returns {boolean}
 */
const isValidFuncArg = ({ name, argCount }) => {
    switch (name) {
        case exports.funcName.IF:
            return argCount === 3;
        case exports.funcName.AVERAGE:
        case exports.funcName.CONCAT:
        case exports.funcName.SUM:
            return true;
        default:
            return argCount <= 1;
    }
};
/**
 * 拋出錯誤訊息
 * @param {ErrorMessage} errorMessage - 錯誤資訊
 */
const throwError = (errorMessage) => {
    const { message } = errorMessage, info = __rest(errorMessage, ["message"]);
    const error = new Error(message);
    throw Object.assign(error, info);
};
class NuLinter {
    constructor() {
        // 公式字串長度
        this.length = 0;
        // 公式字串、前一字符、當前字符、後一字符、表單元件項目、函式名稱
        this.text =
            this.prevChar =
                this.char =
                    this.nextChar =
                        this.itemSn =
                            this.funcName =
                                "";
        // 括號配對佇列、引號配對佇列、表單項目配對佇列
        this.pStack = [];
        this.qStack = [];
        this.iStack = [];
        // 函式參數佇列
        this.fStack = [];
    }
    /**
     * 重置 linter
     *
     * @param {string} text - 公式字串Ｆ
     */
    reset(text = "") {
        var _a;
        // 公式字串
        this.text = text;
        // 公式字串長度
        this.length = text.length;
        // 前一字符、當前字符、表單元件項目、函式名稱
        this.prevChar = this.char = this.itemSn = this.funcName = "";
        // 後一字符
        this.nextChar = (_a = text.charAt(0)) !== null && _a !== void 0 ? _a : "";
        // 括號配對佇列、引號配對佇列、表單項目配對佇列
        this.pStack = [];
        this.qStack = [];
        this.iStack = [];
        // 函式參數佇列
        this.fStack = [];
    }
    /**
     * 驗證公式
     *
     * @param {string} text - 公式字串
     * @returns {object} - 錯誤訊息
     */
    verify(text) {
        var _a, _b, _c;
        this.reset(text);
        try {
            for (let pos = 0; pos < text.length; pos++) {
                // 更新字符狀態
                this.prevChar = (_a = this.char) !== null && _a !== void 0 ? _a : "";
                this.char = (_b = this.nextChar) !== null && _b !== void 0 ? _b : "";
                this.nextChar = (_c = text.charAt(pos + 1)) !== null && _c !== void 0 ? _c : "";
                switch (true) {
                    // 跳過 \ 後的字符、跳過數字的字符
                    case isSyntax(SYNTAX_slash, this.prevChar):
                    case isSyntax(SYNTAX_digit, this.char):
                        continue;
                    // 遇到小數點
                    case isSyntax(SYNTAX_dot, this.char):
                        if (!isSyntax(SYNTAX_digit, this.prevChar) ||
                            !isSyntax(SYNTAX_digit, this.nextChar))
                            throwError({ message: ERROR.syntaxError, pos: pos });
                        continue;
                    // 存在等待配對的引號
                    case this.qStack.length > 0:
                        this.waitForQuote(pos);
                        continue;
                    // 遇到尚未配對的引號
                    case !this.qStack.length && isSyntax(SYNTAX_quote, this.char):
                        this.meetQuote(pos);
                        continue;
                    // 存在等待配對的表單項目
                    case this.iStack.length > 0:
                        this.waitForItemEnd(pos);
                        continue;
                    // 遇到尚未配對的表單項目開頭 {
                    case !this.iStack.length && isSyntax(SYNTAX_bracket_l, this.char):
                        this.meetStartOfItem(pos);
                        continue;
                    // 沒有可配對的表單項目結尾 }
                    case this.iStack.length && isSyntax(SYNTAX_bracket_r, this.char):
                        throwError({ message: ERROR.invalidItem, pos: pos });
                        continue;
                    // 遇到等待配對的括號 )
                    case isSyntax(SYNTAX_paren_r, this.char):
                        this.meetRightParen(pos);
                        continue;
                    // 遇到尚未配對的括號 (
                    case isSyntax(SYNTAX_paren_l, this.char):
                        this.meetLeftParen(pos);
                        continue;
                    // 遇到大寫字母
                    case isSyntax(SYNTAX_upper_case, this.char):
                        this.meetUppercase(pos);
                        continue;
                    // 遇到數學符號 * | /
                    case isSyntax(SYNTAX_arith, this.char):
                        this.meetArith(pos);
                        continue;
                    // 遇到正負號 + | -
                    case isSyntax(SYNTAX_sign, this.char):
                        this.meetSign(pos);
                        continue;
                    // 遇到等於符號 =
                    case isSyntax(SYNTAX_equal, this.char):
                        this.meetEqual(pos);
                        continue;
                    // 遇到大於符號 >
                    case isSyntax(SYNTAX_gt, this.char):
                        this.meetGt(pos);
                        continue;
                    // 遇到小於符號 <
                    case isSyntax(SYNTAX_lt, this.char):
                        this.meetLt(pos);
                        continue;
                    // 遇到逗號 ,
                    case isSyntax(SYNTAX_comma, this.char):
                        this.meetComma(pos);
                        continue;
                    default:
                        throwError({ message: ERROR.syntaxError, pos: pos });
                }
            }
            // 檢查是否剩下尚未配對的表單項目
            this.checkUnmatchedItem();
            // 檢查是否剩下尚未配對的引號
            this.checkUnmatchedQuote();
            // 檢查是否剩下尚未配對的括號
            this.checkUnmatchedParen();
        }
        catch (error) {
            // 捕獲錯誤
            return this.errorMsg(error);
        }
        // 沒有錯誤，視為合法的公式
        return null;
    }
    /**
     * 取得錯誤訊息
     *
     * @param {ErrorMessage} error - 錯誤資訊
     * @returns {object}
     */
    errorMsg(error) {
        const { message: type, pos, length = 1, text } = error;
        const fromPos = (position) => position <= 0 ? 0 : position;
        const toPos = (position) => position >= this.length ? this.length : position;
        switch (type) {
            // 括號不對稱
            case ERROR.unmatchedParen:
                return {
                    from: fromPos(pos),
                    to: toPos(pos + 1),
                    severity: "error",
                    message: `語法錯誤，括號不對稱: ${ERROR.unmatchedParen}`,
                };
            // 引號不對稱
            case ERROR.unmatchedQuote:
                return {
                    from: fromPos(pos),
                    to: toPos(pos + 1),
                    severity: "error",
                    message: `語法錯誤，引號不對稱: ${ERROR.unmatchedQuote}`,
                };
            // 不合法的項目元件
            case ERROR.invalidItem:
                return {
                    from: fromPos(pos),
                    to: toPos(pos + length),
                    severity: "error",
                    message: `語法錯誤，不合法的項目元件: ${ERROR.invalidItem}`,
                };
            // 缺少標示符
            case ERROR.missingOperator:
                return {
                    from: fromPos(pos + 1),
                    to: toPos(pos + 1),
                    severity: "error",
                    message: `語法錯誤，缺少標示符: ${ERROR.missingOperator}`,
                };
            // 錯誤的標示符
            case ERROR.invalidOperator:
                return {
                    from: fromPos(pos),
                    to: toPos(pos + length),
                    severity: "error",
                    message: `語法錯誤，錯誤的標示符: ${ERROR.invalidOperator}`,
                };
            // 錯誤的函式
            case ERROR.invalidFuncName:
                return {
                    from: fromPos(pos),
                    to: toPos(pos + length),
                    severity: "error",
                    message: `語法錯誤，錯誤的函式: ${ERROR.invalidFuncName}`,
                };
            // 錯誤的參數數量
            case ERROR.invalidArgCount:
                return {
                    from: fromPos(pos),
                    to: toPos(pos + length),
                    severity: "error",
                    message: `語法錯誤，${text} 錯誤的參數數量: ${ERROR.invalidArgCount}`,
                };
            // 語法錯誤
            case ERROR.syntaxError:
                return {
                    from: fromPos(pos),
                    to: toPos(pos + length),
                    severity: "error",
                    message: `語法錯誤，無法識別的字符: ${ERROR.syntaxError}`,
                };
            default:
                return {
                    from: 0,
                    to: this.length,
                    severity: "error",
                    message: `語法錯誤: ${type}`,
                };
        }
    }
    //#region 字符的驗證規則
    /**
     * 存在等待配對的引號
     *
     * @param {number} pos - 字符位置
     */
    waitForQuote(pos) {
        // 遇到配對的引號 "
        if (isSyntax(SYNTAX_quote, this.char)) {
            // 消除配對的引號
            this.qStack.pop();
            // 檢查下一個字符是否為一個參數的合法後綴
            if (!isSyntax(SYNTAX_trail_to_arg, this.nextChar))
                throwError({ message: ERROR.missingOperator, pos });
        }
    }
    /**
     * 遇到尚未配對的引號
     *
     * @param {number} pos - 字符位置
     */
    meetQuote(pos) {
        // 檢查上一個字符是否為一個參數的合法前綴
        if (!isSyntax(SYNTAX_lead_to_arg, this.prevChar))
            throwError({ message: ERROR.missingOperator, pos: pos - 1 });
        // 紀錄引號位置
        this.qStack.push(pos);
    }
    /**
     * 遇到可配對的表單項目結尾 }
     *
     * @param {number} pos - 字符位置
     */
    meetEndOfItem(pos) {
        // 項目序號格式不符
        if (!isSyntax(SYNTAX_item, this.itemSn)) {
            throwError({
                message: ERROR.invalidItem,
                pos: pos - this.itemSn.length - 1,
                length: this.itemSn.length + 1,
            });
        }
        // 檢查下一個字符是否為一個參數的合法後綴
        if (!isSyntax(SYNTAX_trail_to_arg, this.nextChar))
            throwError({ message: ERROR.missingOperator, pos });
        // 消除配對的表單項目字符
        this.iStack.pop();
        // 清空紀錄表單序號
        this.itemSn = "";
    }
    /**
     * 遇到表單項目開頭 {
     *
     * @param {number} pos - 字符位置
     */
    meetStartOfItem(pos) {
        // 檢查上一個字符是否為一個參數的合法前綴
        if (this.itemSn.length > 0 || !isSyntax(SYNTAX_lead_to_arg, this.prevChar))
            throwError({ message: ERROR.missingOperator, pos: pos - 1 });
        this.iStack.push(pos);
    }
    /**
     * 存在等待配對的表單項目
     *
     * @param {number} pos - 字符位置
     */
    waitForItemEnd(pos) {
        // 遇到可配對的表單項目結尾 }
        if (isSyntax(SYNTAX_bracket_r, this.char)) {
            this.meetEndOfItem(pos);
            return;
        }
        // 繼續紀錄表單序號
        this.itemSn += this.char;
    }
    /**
     * 遇到等待配對的括號 )
     *
     * @param {number} pos - 字符位置
     */
    meetRightParen(pos) {
        // 檢查下一個字符是否為一個參數的合法後綴
        if (!isSyntax(SYNTAX_trail_to_arg, this.nextChar))
            throwError({ message: ERROR.missingOperator, pos });
        if (!this.pStack.length)
            throwError({ message: ERROR.unmatchedParen, pos });
        else
            this.pStack.pop();
        const funcArg = this.fStack.pop();
        if (!isValidFuncArg(Object.assign(funcArg, { argCount: funcArg.argCount + 1 })))
            throwError({
                message: ERROR.invalidArgCount,
                pos: funcArg.pos - funcArg.name.length,
                length: pos - funcArg.pos + 3,
                text: funcArg.name,
            });
    }
    /**
     * 遇到尚未配對的括號 (
     *
     * @param {number} pos - 字符位置
     */
    meetLeftParen(pos) {
        // 檢查上一個字符是否為函式字符，或是一個參數的合法前綴
        if (!isSyntax(SYNTAX_upper_case, this.prevChar) &&
            !isSyntax(SYNTAX_lead_to_arg, this.prevChar))
            throwError({ message: ERROR.missingOperator, pos: pos - 1 });
        // 檢查是否為宣告函式
        if (isSyntax(SYNTAX_upper_case, this.prevChar) && this.funcName.length) {
            // 是否為註冊的函式
            if (!isSyntax(SYNTAX_valid_func, this.funcName))
                throwError({
                    message: ERROR.invalidFuncName,
                    pos: pos - this.funcName.length,
                    length: this.funcName.length,
                });
        }
        this.fStack.push({ name: this.funcName, argCount: 0, pos: pos });
        this.funcName = "";
        this.pStack.push(pos);
    }
    /**
     * 遇到大寫字母
     *
     * @param {number} pos - 字符位置
     */
    meetUppercase(pos) {
        // 下一字符是否為一個函式的合法結尾
        if (!isSyntax(SYNTAX_end_of_func, this.nextChar))
            throwError({ message: ERROR.invalidFuncName, pos: pos + 1 });
        this.funcName += this.char;
    }
    /**
     * 遇到數學符號 * | /
     *
     * @param {number} pos - 字符位置
     */
    meetArith(pos) {
        if (!isValidOperator(this.prevChar, this.nextChar))
            throwError({ message: ERROR.invalidOperator, pos: pos });
    }
    /**
     * 遇到正負號 + | -
     *
     * @param {number} pos - 字符位置
     */
    meetSign(pos) {
        // 後面跟著數字，表示數字的正負號，為合法表達
        if (isSyntax(SYNTAX_digit, this.nextChar))
            return;
        // 檢查是否前後為合法的參數
        if (!isValidOperator(this.prevChar, this.nextChar))
            throwError({ message: ERROR.invalidOperator, pos: pos });
    }
    /**
     * 遇到等於符號 =
     *
     * @param {number} pos - 字符位置
     */
    meetEqual(pos) {
        // 符合 >= 或 <=
        if (isSyntax(SYNTAX_gt, this.prevChar) ||
            isSyntax(SYNTAX_lt, this.prevChar)) {
            // 檢查後一字符是否為一個參數的合法開頭
            if (!isSyntax(SYNTAX_start_of_arg, this.nextChar))
                throwError({ message: ERROR.invalidOperator, pos: pos - 1, length: 2 });
            return;
        }
        // 檢查是否前後為合法的參數
        if (!isValidOperator(this.prevChar, this.nextChar))
            throwError({ message: ERROR.invalidOperator, pos: pos });
    }
    /**
     * 遇到大於符號 >
     *
     * @param {number} pos - 字符位置
     */
    meetGt(pos) {
        // 符合 <>
        if (isSyntax(SYNTAX_lt, this.prevChar)) {
            // 檢查後一字符是否為一個參數的合法開頭
            if (!isSyntax(SYNTAX_start_of_arg, this.nextChar))
                throwError({ message: ERROR.invalidOperator, pos: pos - 1, length: 2 });
            return;
        }
        // 符合 >=
        if (isSyntax(SYNTAX_equal, this.nextChar)) {
            // 檢查前一字符是否為合法的參數結束
            if (!isSyntax(SYNTAX_end_of_arg, this.prevChar))
                throwError({ message: ERROR.invalidOperator, pos: pos - 1, length: 2 });
            return;
        }
        // 檢查是否前後為合法的參數
        if (!isValidOperator(this.prevChar, this.nextChar))
            throwError({ message: ERROR.invalidOperator, pos: pos });
    }
    /**
     * 遇到小於符號 <
     *
     * @param {number} pos - 字符位置
     */
    meetLt(pos) {
        // 符合 <= 或 <>
        if (isSyntax(SYNTAX_equal, this.nextChar) ||
            isSyntax(SYNTAX_gt, this.nextChar)) {
            // 檢查前一字符是否為合法的參數結束
            if (!isSyntax(SYNTAX_end_of_arg, this.prevChar))
                throwError({ message: ERROR.invalidOperator, pos: pos - 1, length: 2 });
            return;
        }
        // 檢查是否前後為合法的參數
        if (!isValidOperator(this.prevChar, this.nextChar))
            throwError({ message: ERROR.invalidOperator, pos: pos });
    }
    /**
     * 遇到逗號 ,
     *
     * @param {number} pos - 字符位置
     */
    meetComma(pos) {
        // 檢查是否前後為合法的參數
        if (!isValidOperator(this.prevChar, this.nextChar))
            throwError({ message: ERROR.invalidOperator, pos: pos });
        const funcArg = this.fStack.pop();
        if (Object.keys(funcArg).length === 0) {
            throwError({
                message: ERROR.invalidArgCount,
                pos: 0,
                length: this.length,
            });
        }
        this.fStack.push(Object.assign(funcArg, { argCount: funcArg.argCount + 1 }));
    }
    /**
     * 檢查是否剩下尚未配對的表單項目
     */
    checkUnmatchedItem() {
        var _a;
        const unmatchedItem = (_a = this.iStack.pop()) !== null && _a !== void 0 ? _a : -1;
        if (unmatchedItem > -1) {
            throwError({ message: ERROR.invalidItem, pos: unmatchedItem });
        }
    }
    /**
     * 檢查是否剩下尚未配對的引號
     */
    checkUnmatchedQuote() {
        var _a;
        const unmatchedQuote = (_a = this.qStack.pop()) !== null && _a !== void 0 ? _a : -1;
        if (unmatchedQuote > -1)
            throwError({ message: ERROR.unmatchedQuote, pos: unmatchedQuote });
    }
    /**
     * 檢查是否剩下尚未配對的括號
     */
    checkUnmatchedParen() {
        var _a;
        const unmatchedParen = (_a = this.pStack.pop()) !== null && _a !== void 0 ? _a : -1;
        if (unmatchedParen > -1)
            throwError({ message: ERROR.unmatchedParen, pos: unmatchedParen });
    }
}
const nuLint = new NuLinter();
const nuformulaLinter = (callback) => {
    return lint.linter((view) => {
        const { state } = view;
        const error = nuLint.verify(state.doc.toString());
        callback(error);
        if (error === null || error === void 0 ? void 0 : error.severity)
            return [error];
        return [];
    });
};

// 語言標籤樣式
function nuformulaHighlightStyle() {
    return language.syntaxHighlighting(language.HighlightStyle.define([
        { tag: highlight.tags.keyword, color: "#B157D0" },
        { tag: highlight.tags.string, color: "#F7A452" },
        { tag: highlight.tags.number, color: "#5C9CE5" },
        { tag: highlight.tags.operator, color: "#404040" },
        { tag: highlight.tags.variableName, color: "#6E7796" },
        { tag: highlight.tags.paren, color: "#404040" },
        { tag: highlight.tags.separator, color: "#404040" },
    ]));
}

/**
 * 偵測自動選字方法
 *
 * @param {Array} options - 可選選項
 * @returns {Function}
 */
function setAutocomplete(options) {
    return (context) => {
        let word = context.matchBefore(/(\w|[\u4E00-\u9FFF])*/);
        if (word.from == word.to && !context.explicit)
            return null;
        return {
            from: word.from,
            options: options,
        };
    };
}
/**
 * 輸出 自動選字 掛件
 *
 * @param {Object} options - 可選選項
 * @returns {Extension}
 */
function nuformulaAutocomplete(formItems) {
    const funcNameList = Object.values(exports.funcName).map((func) => ({
        label: func,
        type: "method",
        apply: `${func}()`,
    }));
    const itemList = Object.values(formItems).map((value) => ({
        label: value.options.label,
        type: "variable",
        apply: `{${value.sn}}`,
    }));
    const autocompleteOptions = [].concat(funcNameList, itemList);
    return autocomplete.autocompletion({
        override: [setAutocomplete(autocompleteOptions)],
    });
}

const OP = {
    /* 數學運算子 */
    add: "add",
    subtract: "subtract",
    time: "time",
    divide: "divide",
    eq: "eq",
    gt: "gt",
    lt: "lt",
    gte: "gte",
    lte: "lte",
    neq: "neq",
    /* 函式運算子 */
    equal: "equal",
    sum: "sum",
    if: "if",
    concat: "concat",
    average: "average", // -------------- AVERAGE
};
/**
 * ==================================
 * 參考 Microsoft Excel 規格
 *
 * @see https://support.microsoft.com/zh-tw/office/78be92ad-563c-4d62-b081-ae6da5c2ca69
 * @see https://support.microsoft.com/zh-tw/office/5f91f4e9-7b42-46d2-9bd1-63f26a86c0eb
 * ==================================
 */
const NuEvalutionLib = {
    //#region 算術運算子
    // 計算原則：先計算再 round up
    /**
     * 加法 (+)
     *
     * @param {Array} args - 參數
     * @returns {number} 兩數相加的結果
     * @description
     *  - 範例: =3+3
     *  - 接受參數數量: 2
     */
    [OP.add]: (args) => {
        return Number(args[0]) + Number(args[1]);
    },
    /**
     * 減法 (-)
     *
     * @param {Array} args - 參數
     * @returns {number} 兩數相減的結果
     * @description
     *  - 範例: =3-3
     *  - 接受參數數量: 2
     */
    [OP.subtract]: (args) => {
        return Number(args[0]) - Number(args[1]);
    },
    /**
     * 乘法 (*)
     *
     * @param {Array} args - 參數
     * @returns {number} 兩數相乘的結果
     * @description
     *  - 範例: =3*3
     *  - 接受參數數量: 2
     */
    [OP.time]: (args) => {
        return Number(args[0]) * Number(args[1]);
    },
    /**
     * 除法 (/)
     *
     * @param {Array} args - 參數
     * @returns {number} 兩數相除的結果
     * @description
     *  - 範例: =3/3
     *  - 接受參數數量: 2
     */
    [OP.divide]: (args) => {
        if (isEmptyValue(args[1]) || !isNumber(args[1]) || args[1] === 0)
            return NaN;
        return Number(args[0]) / Number(args[1]);
    },
    //#endregion
    //#region 比較運算子
    /**
     * 等於 (=)
     *
     * @param {Array} args - 參數
     * @returns {boolean} 兩數是否相等
     * @description
     *  - 範例: = A1 = B1
     *  - 接受參數數量: 2
     */
    [OP.eq]: (args) => {
        return args[0] === args[1];
    },
    /**
     * 大於 (>)
     *
     * @param {Array} args - 參數
     * @returns {boolean} arg[0] 是否大於 arg[1]
     * @description
     *  - 範例: = A1>B1
     *  - 接受參數數量: 2
     */
    [OP.gt]: (args) => {
        return args[0] > args[1];
    },
    /**
     * 小於 (<)
     *
     * @param {Array} args - 參數
     * @returns {boolean} arg[0] 是否小於 arg[1]
     * @description
     *  - 範例: = A1<B1
     *  - 接受參數數量: 2
     */
    [OP.lt]: (args) => {
        return args[0] < args[1];
    },
    /**
     * 大於或等於 (>=)
     *
     * @param {Array} args - 參數
     * @returns {boolean} arg[0] 是否大於等於 arg[1]
     * @description
     *  - 範例: = A1>=B1
     *  - 接受參數數量: 2
     */
    [OP.gte]: (args) => {
        return args[0] >= args[1];
    },
    /**
     * 小於或等於 (<=)
     *
     * @param {Array} args - 參數
     * @returns {boolean} arg[0] 是否小於等於 arg[1]
     * @description
     *  - 範例: = A<=B1
     *  - 接受參數數量: 2
     */
    [OP.lte]: (args) => {
        return args[0] <= args[1];
    },
    /**
     * 不等於 (<>)
     *
     * @param {Array} args - 參數
     * @returns {boolean} 兩數是否不相等
     * @description
     *  - 範例: = A1<>B1
     *  - 接受參數數量: 2
     */
    [OP.neq]: (args) => {
        return args[0] !== args[1];
    },
    //#endregion
    /* 公式運算 - 常用函式 */
    /**
     * =，等於arg[0]，為公式最底層的函式
     *
     * @param {Array} args - 參數
     * @returns {any} 返回計算結果
     * @description
     *  - 範例: =100
     *  - 接受參數數量: 1
     */
    [OP.equal]: (args) => {
        return args[0];
    },
    /**
     * SUM，使用此函數來加總儲存格中的值
     *
     * @param {Array} args - 參數
     * @returns {any} 返回計算結果
     * @description
     *  - 範例: =SUM(number1, [number2], ...)
     *  - 接受參數數量: n
     * @see https://support.microsoft.com/zh-tw/office/043e1c7d-7726-4e80-8f32-07b23e057f89
     */
    [OP.sum]: (args) => {
        return args.reduce((sum, arg) => sum + arg, 0);
    },
    /**
     * IF，使用此函數以在條件符合時傳回一個值，並在條件不符合時傳回另一個值。
     *
     * @param {Array} args - 參數
     * @returns {any} 返回計算結果
     * @description
     *  - 範例: =IF(arg[0],arg[1],arg[2])
     *    若 arg[0] 為 true，返回 arg[1]，否則返回 arg[2]
     *  - 接受參數數量: 3
     * @see https://support.microsoft.com/zh-tw/office/69aed7c9-4e8a-4755-a9bc-aa8bbff73be2
     */
    [OP.if]: (args) => {
        return args[0] ? args[1] : args[2];
    },
    /**
     * CONCAT，合並多個範圍和/或字串中的文字
     *
     * @param {Array} args - 參數
     * @returns {any} 返回計算結果
     * @description
     *  - 範例: =CONCAT(text1, [text2],…)
     *  - 接受參數數量: n
     * @see https://support.microsoft.com/zh-tw/office/9b1a9a3f-94ff-41af-9736-694cbd6b4ca2
     */
    [OP.concat]: (args) => {
        return args.join("");
    },
    /**
     * AVERAGE，傳回引數的平均值
     *
     * @param {Array} args - 參數
     * @returns {any} 返回計算結果
     * @description
     *  - 範例: =AVERAGE(number1, [number2], ...)
     *  - 接受參數數量: n
     * @see https://support.microsoft.com/zh-tw/office/047bac88-d466-426c-a32b-8f33eb960cf6
     */
    [OP.average]: (args) => {
        return (args.reduce((sum, arg) => sum + arg, 0) /
            args.length);
    },
};

const OP_TYPE = {
    operator: "operator",
    operand: "operand", // ------- 運算元 - 指結合物件、組成運算式的方式，用來計算結果
};
const ARG_TYPE = {
    constant: "constant",
    number: "number",
    item: "item",
    math: "math",
    function: "function", // ----- 函式
};
// 表單項目類型字串
const WIDGET_TYPE = {
    form: "form",
    divider: "divider",
    block: "block",
    table: "table",
    grid: "grid",
    input: "input",
    textarea: "textarea",
    datetime: "datetime",
    datetimeRange: "datetime_range",
    number: "number",
    radio: "radio",
    checkbox: "checkbox",
    select: "select",
    selectMultiple: "select_multiple",
    upload: "upload",
    uploadImage: "upload_image",
    staff: "staff",
    staffMultiple: "staff_multiple",
    dept: "dept",
    deptMultiple: "dept_multiple",
    subform: "subform",
    summary: "summary",
    serialNumber: "serial_number",
    info: "info", // ------------------------- 說明文字
};
/**
 * 移除 " 字符
 *
 * @param {string} str - 輸入字串
 * @returns {string}
 */
function removeQuotation(str) {
    return String(str).replace(/\"/g, "");
}
class FormulaEvaluation {
    constructor() {
        this.formItems = {};
    }
    /**
     * 初始化公式計算工具
     *
     * @param {object} formItems - 所有可用表單元件
     */
    init(formItems) {
        this.formItems = formItems !== null && formItems !== void 0 ? formItems : {};
    }
    /**
     * 取得公式計算方法
     *
     * @param {Array} postfixStack - postfix 公式佇列
     * @returns {Function}
     */
    getEvaluation(postfixStack) {
        return (scopedData) => {
            var _a, _b;
            // postfix 佇列
            let stack = [...postfixStack];
            // 運算元佇列
            let operandStack = [];
            // 引數佇列
            let argumentStack = [];
            // 暫存計算結果
            let evaResult = "";
            // 掃描 postfix 表達式
            while (!isEmptyValue(stack)) {
                const currentArg = stack.shift();
                // 每當遇到運算元時，將其推入 stack
                if (currentArg.op === OP_TYPE.operand) {
                    operandStack.push(currentArg);
                }
                // 每當遇到運算子
                else if (currentArg.argCount) {
                    // 從 postfix 佇列中 pop 出所需數量個運算元，push 進運算子引數佇列
                    argumentStack = [];
                    for (let i = 0; i < currentArg.argCount; i++) {
                        const operand = operandStack.pop();
                        if (operand)
                            argumentStack.unshift(this.getValue(operand, scopedData));
                    }
                    // 將這些運算元與運算子進行運算
                    evaResult = NuEvalutionLib[currentArg.value](argumentStack);
                    // 將結果再次推回 postfix 佇列
                    operandStack.push({
                        op: OP_TYPE.operand,
                        type: isNumber(evaResult) ? ARG_TYPE.number : "",
                        value: evaResult,
                    });
                }
            }
            // 輸出計算結果
            return (_b = (_a = operandStack.pop()) === null || _a === void 0 ? void 0 : _a.value) !== null && _b !== void 0 ? _b : "";
        };
    }
    /**
     * 取得參數值
     *
     * @param {object} arg - 參數物件
     * @param {object} formData - 當前表單填寫值
     * @returns {any} - 運算元的值 (operand)
     */
    getValue(arg, formData) {
        switch (arg === null || arg === void 0 ? void 0 : arg.type) {
            // 常數字串
            case ARG_TYPE.constant:
                return removeQuotation(arg.value);
            // 數字
            case ARG_TYPE.number:
                return truncateMaxNumber(arg.value);
            // 表單元件
            case ARG_TYPE.item:
                switch (this.formItems[arg.value].type) {
                    // 單行文字元件
                    case WIDGET_TYPE.input:
                        return removeQuotation(formData[arg.value]);
                    // 數字元件
                    case WIDGET_TYPE.number:
                        return truncateMaxNumber(formData[arg.value]);
                    default:
                        return arg.value;
                }
            default:
                return arg === null || arg === void 0 ? void 0 : arg.value;
        }
    }
}
const nuformulaEvaluation = new FormulaEvaluation();

// 定義語言
const NuformulaLanguage = language.LRLanguage.define({
    parser: parser.configure({
        props: [
            language.indentNodeProp.add({
                Application: () => 0,
            }),
            highlight.styleTags({
                Keyword: highlight.tags.keyword,
                String: highlight.tags.string,
                Number: highlight.tags.number,
                Operator: highlight.tags.operator,
                Item: highlight.tags.variableName,
                "( )": highlight.tags.paren,
                Comma: highlight.tags.separator,
            }),
        ],
    }),
});
// 輸出語言
function nuformula() {
    return new language.LanguageSupport(NuformulaLanguage);
}

exports.NuEvalutionLib = NuEvalutionLib;
exports.NuformulaLanguage = NuformulaLanguage;
exports.isEmptyValue = isEmptyValue;
exports.isNumber = isNumber;
exports.nuLint = nuLint;
exports.nuformula = nuformula;
exports.nuformulaAutocomplete = nuformulaAutocomplete;
exports.nuformulaEvaluation = nuformulaEvaluation;
exports.nuformulaHighlightStyle = nuformulaHighlightStyle;
exports.nuformulaItemWidget = nuformulaItemWidget;
exports.nuformulaLinter = nuformulaLinter;
exports.truncateMaxNumber = truncateMaxNumber;
